<?php
/*******************************************************************
 * ClassMappingsHandler.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/

require_once(WebOrb . "Config/ORBConfigHandler.php");

class ClassMappingsHandler
    extends ORBConfigHandler
{
    public function configure($parent, $configContext, DOMNode $documentElement)
    {
       $section = $documentElement->getElementsByTagName("classMappings")->item(0); // check required !
       
        foreach (($section->childNodes) as $element)
        {
            if (!($element instanceof DOMElement))
            {
                continue;
            }

            $elements = $element->getElementsByTagName("clientClass");
            $clientClass = trim($elements->item(0)->textContent);

            $elements = $element->getElementsByTagName("serverClass");
            $serverClass = trim($elements->item(0)->textContent);
            
            $type = TypeLoader::loadType($serverClass);
            
            Log::log(LoggingConstants::DEBUG, $clientClass . " : " . $serverClass);
            
            ORBConfig::getInstance()->getTypeMapper()->_addClientClassMapping($clientClass, $type);
        }
    }
}

?>