<?php
/*******************************************************************
 * ORBConfigHandler.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/

 require_once(WebOrb . "Config/IConfigurationSectionHandler.php");

 abstract class ORBConfigHandler
    implements IConfigurationSectionHandler
 {
	private $m_configNode;
    private $m_config;
    
    
	public function create( $parent, $configContext, DOMNode $section )
	{
        $this->m_config = $configContext;
		$this->m_configNode = $section;
		
		return $this->configure( $parent, $configContext, $section );
	}

    public abstract function configure($parent, $configContext, DOMNode $section);
    
    public function setORBConfig(ORBConfig $config)
    {
      $this->m_config = $config;
    }
    
    public function getORBConfig()
    {
        return $this->m_config;  
    }

    public function getConfigNode()
    {
        return $this->m_configNode;    
    }

    public function saveConfig()
    {
      
    }
 }

?>