<?php
/*******************************************************************
 * ServicesConfigHandler.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



require_once(WebOrb . "Config/ORBConfig.php");
require_once(WebOrb . "Config/ORBConfigHandler.php");

class ServicesConfigHandler
    extends ORBConfigHandler
{

    public function configure($parent, $configContext, DOMNode $documentElement)
    {
        $section = $documentElement->getElementsByTagName("services")->item(0);  // check required !
        
        
      
        foreach (($section->childNodes) as $element)
        {
            if (!($element instanceof DOMElement))
            {
                continue;
            }

            $nameElements = $element->getElementsByTagName("name");
            $serviceName = trim($nameElements->item(0)->textContent);

            $idElements = $element->getElementsByTagName("serviceId");
            $serviceId = trim($idElements->item(0)->textContent);
            ORBConfig::getInstance()->getServiceRegistry()->_addMapping($serviceName, $serviceId, array());
        }
    }

}

?>
