<?php
/*******************************************************************
 * Handlers.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



require_once(WebOrb . "Util/Logging/Log.php");

class Handlers
{

    private $m_invHandlers = array();
    private $m_inspHandlers = array();

    public function __construct()
    {
    }

    public function addInvocationHandler($handler)
    {
        $this->m_invHandlers[] = $handler;
    }

    public function addInspectionHandler($handler)
    {
        $this->m_inspHandlers[] = $handler;
    }

    public function invoke($className, $methodName, $arguments)
    {
        Log::log(LoggingConstants::DEBUG, "Called");

        for ($index = 0; $index < count($this->m_invHandlers); $index ++)
        {
            $value = $this->m_invHandlers[$index]->invoke($className, $methodName, $arguments);

            if($value != NULL)
            {
                return $value;
            }
        }

        return NULL;
    }

    public function inspect($className, $methodName, $arguments)
    {
        Log::log(LoggingConstants::DEBUG, "Called");

        for ($index = 0; $index < count($this->m_inspHandlers); $index ++)
        {
            $this->m_inspHandlers[$index]->inspect($className, $methodName, $arguments);
        }
    }

}

?>
