<?php
/*******************************************************************
 * Body.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



require_once(WebOrb . "Util/Logging/Log.php");
require_once(WebOrb . "Reader/ArrayType.php");
require_once(WebOrb . "Reader/IAdaptingType.php");

class Body
{

    private $m_serviceURI;
    private $m_responseURI;
    private $m_length;
    private $m_dataObject;

    private $m_responseDataObject;

    public function __construct($serviceURI, $responseURI, $length, $dataObject)
    {
        Log::log(LoggingConstants::DEBUG, "serviceURI:" . $serviceURI);

        $this->m_serviceURI = $serviceURI;
        $this->m_responseURI = $responseURI;
        $this->m_length = $length;

        if($dataObject instanceof IAdaptingType)
        {
            if($dataObject instanceof ArrayType)
            {
                $this->m_dataObject = $dataObject->getArray();
            }
            else
            {
                $this->m_dataObject = array($this->m_dataObject);
            }
        }
        else
        {
            $this->m_dataObject = $dataObject;
        }
    }

    public function getServiceURI()
    {
        return $this->m_serviceURI;
    }

    public function getResponseURI()
    {
        return $this->m_responseURI;
    }

    public function getLength()
    {
        return $this->m_length;
    }

    public function getDataObject()
    {
        return $this->m_dataObject;
    }
    
    public function setDataObject($dataObject)
    {
        return $this->m_dataObject = $dataObject;
    }

    public function setResponseDataObject($value)
    {
        $this->m_responseDataObject = $value;
    }

    public function getResponseDataObject()
    {
        return $this->m_responseDataObject;
    }

    public function setResponseURI($responseUri)
    {
        $this->m_responseURI = $responseUri;
    }

}

?>
