<?php
/*******************************************************************
 * ArrayReader.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



require_once(WebOrb . "Reader/ITypeReader.php");
require_once(WebOrb . "Reader/FlashorbBinaryReader.php");
require_once(WebOrb . "Reader/ParseContext.php");
require_once(WebOrb . "Reader/ArrayType.php");
require_once(WebOrb . "Protocols/AMFMessageFactory.php");

class ArrayReader
    implements ITypeReader
{

    public function __construct()
    {
    }

    public function read(FlashorbBinaryReader $reader, ParseContext $parseContext)
    {
        $length = $reader->readInteger();
        $array = array();

        $arrayType = new ArrayType($array);
        $parseContext->addReference($arrayType);

        for ($index = 0; $index < $length; $index ++)
        {
            $array[] = AmfMessageFactory::readData($reader, $parseContext, null);
        }

        return $arrayType;
    }

}

?>
