<?php
/*******************************************************************
 * BooleanReader.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



require_once(WebOrb . "Reader/ITypeReader.php");
require_once(WebOrb . "Reader/FlashorbBinaryReader.php");
require_once(WebOrb . "Reader/ParseContext.php");
require_once(WebOrb . "Reader/BooleanType.php");

class BooleanReader
    implements ITypeReader
{

    private $m_initialized = false;
    private $m_val;

    public function __construct($initValue = null)
    {
        if (!is_null($initValue))
        {
            $this->m_initialized = true;
            $this->m_val = $initValue;
        }
    }

    public function read(FlashorbBinaryReader $reader, ParseContext $parseContext)
    {
        Log::log(LoggingConstants::DEBUG, "Called");
        
        return new BooleanType(($this->m_initialized)? $this->m_val: $reader->readBoolean());
    }

}

?>
