<?php
/*******************************************************************
 * DataSetInfo.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/


 require_once(WebOrb . "V3Types/AckMessage.php"); // Need to move into util
 
 class DataSetInfo
 {
    public function __construct()
    {
         $this->serverInfo["version"] = 1.0;
         $this->serverInfo["serviceName"] = "Weborb.Reader.Dataset.RemotingDataSet";
         $this->serverInfo["id"] = AckMessage::uuid();// Need to move into util
    }
   
    public $serverInfo = array();
   
    public function setNumberOfRows($numberOfRows)
    {
      $this->serverInfo["totalCount"] = $numberOfRows;      
    }

    public function setCurrentRowIndex($currentRowIndex)
    {
      $this->serverInfo["cursor"] = $currentRowIndex;      
    }
        
    public function setColumnNames(&$columnNames)
    {
      $this->serverInfo["columnNames"] = $columnNames;      
    }
    
    public function setRecordsData(&$records)
    {
      $this->serverInfo["initialData"] = $records;
    }
    
    public function setPagingSize($size )
    {
      $this->serverInfo["pagingSize"] = $size;
    }

 }

?>