<?php
/*******************************************************************
 * RemotingDataSet.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/


require_once(WebOrb . "Reader/Dataset/DataSetInfo.php");

class RemotingDataSet
{
    private $m_dataArr;
    
    public function __construct($dataArr)
    {
        $this->m_dataArr = $dataArr;
    }
  
    public function getDatasetInfo()  
    {
        $rowCount = count($this->m_dataArr);
      
        $dataSetInfo = new DataSetInfo($this);
        
        $dataSetInfo->setCurrentRowIndex(1);
        $dataSetInfo->setNumberOfRows($rowCount);
        $dataSetInfo->setPagingSize($rowCount);
        
        if($rowCount > 0)
        {
          $values = array();
          
          for($i = 0; $i < count($this->m_dataArr); $i++)
            $values[] = array_values((array)$this->m_dataArr[$i]);
          
          $dataSetInfo->setRecordsData($values);  

          $columnNames = array_keys((array)$this->m_dataArr[0]);
                    
          $dataSetInfo->setColumnNames($columnNames); 
        }
        else
        {
           $emptyArr = array();
           $dataSetInfo->setColumnNames($emptyArr); 
           $dataSetInfo->setRecordsData($emptyArr);         
        }
        
        return $dataSetInfo;
    }
}

?>