<?php
/*******************************************************************
 * DateType.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



require_once(WebOrb . "Util/ORBDateTime.php");
require_once(WebOrb . "Reader/IAdaptingType.php");

class DateType
    implements IAdaptingType
{

    private $m_date;

    public function __construct(ORBDateTime $dateTime)
    {
        $this->m_date = $dateTime;

        // some operations with time zone
        // ...
    }

    public function getDefaultType()
    {
        return new ReflectionClass("ORBDateTime");
    }

    public function defaultAdapt()
    {
        return $this->m_date;
    }

    public function adapt($type)
    {
        return $this->defaultAdapt();
    }

    public function canAdaptTo($formalArg)
    {
        if (is_object($formalArg) && ("ReflectionClass" == get_class($formalArg)))
        {
            return ("ORBDateTime" == $formalArg->getName());
        }

        return false;
    }

}

?>