<?php
/*******************************************************************
 * ParseContext.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



require_once(WebOrb . "Reader/IAdaptingType.php");

class ParseContext
{

    private $m_references;
    private $m_stringReferences;
    private $m_classInfos;
    private $m_version;

    public function __construct($version = null)
    {
        $this->m_references = array();
        $this->m_stringReferences = array();
        $this->m_classInfos = array();
        if (!is_null($version))
        {
            $this->m_version = $version;
        }
    }

    public function addReference(IAdaptingType $type, $index = null)
    {
        if (is_null($index))
        {
            $this->m_references[] = $type;
        }
        else
        {
            $this->m_references[$index] = $type;
        }
    }

    public function getReference($index)
    {
        return $this->m_references[$index];
    }

    public function addStringReference($refStr)
    {
        $this->m_stringReferences[] = $refStr;
    }

    public function getStringReference($index)
    {
        return $this->m_stringReferences[$index];
    }

    public function addClassInfoReference($val)
    {
        $this->m_classInfos[] = $val;
    }

    public function getClassInfoReference($index)
    {
        return $this->m_classInfos[$index];
    }

    public function getVersion()
    {
        return $this->m_version;
    }

}

?>
