<?php
/*******************************************************************
 * RemoteReferenceObject.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



require_once(WebOrb . "Reader/IAdaptingType.php");
require_once(WebOrb . "Exceptions/ApplicationException.php");

class RemoteReferenceObject
    implements IAdaptingType
{

    private $m_reference;

    public function __construct($reference)
    {
        $this->m_reference = $reference;
    }

    public static function createReference($referencedObject)
    {
        $referenceId = get_class($referencedObject) + "_proxy_" + uniqid();
        $proxy = new RemoteReferenceObject($referenceId);
        $_SESSION[$referenceId] = $referencedObject;
        return $proxy;
    }

    public function getDefaultType()
    {
        throw new ApplicationException("TBD");
    }

    public function defaultAdapt()
    {
        return $this->m_reference;
    }

    public function adapt($type)
    {
        return ObjectFactories::createServiceObject($type);
    }

    public function canAdaptTo($formalArg)
    {
        return ($formalArg instanceof ReflectionClass);
    }

    public function getServiceID()
    {
        return $this->m_reference;
    }

}

?>
