<?php
/*******************************************************************
 * XmlDataType.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



require_once(WebOrb . "Reader/IAdaptingType.php");
require_once(WebOrb . "Exceptions/ApplicationException.php");

class XmlDataType
    implements IAdaptingType
{

    private $m_document;

    public function __construct(DomDocument $document)
    {
        $this->m_document = $document;
    }

    public function getDefaultType()
    {
        return new ReflectionClass("DomDocument");
    }

    public function defaultAdapt()
    {
        return $this->m_document;
    }

    public function adapt($type)
    {
        if ($type->isSubclassOf(new ReflectionClass("DomDocument")))
        {
            return $this->m_document;
        }
        else if ($type->isSubclassOf(new ReflectionClass("DomElement"))
                || $type->isSubclassOf(new ReflectionClass("DomNode")))
        {
            return $this->m_document->documentElement;
        }
        else
        {
            throw new ApplicationException( "unable to adapt type " + $type  + " to xml" );
        }
    }

    public function canAdaptTo($formalArg)
    {
        return FALSE;
    }

}

?>
