<?php
/*******************************************************************
 * RoleNameRestriction.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/

  require_once(WebOrb . "Security/IRestriction.php");
  require_once(WebOrb . "Exceptions/ConfigurationException.php");
  
  class RoleNameRestriction 
      implements IRestriction
  {
    private $m_roleName;
    
    public function __construct($roleName)
    {
      $this->m_roleName = $roleName;
    }
    
    public function pass()
    {
      $credentials = ThreadContext::currentCallerCredentials();

      if($credentials == null)
      {       
		// return false, authorization is required
		return false;          
      }

      $userName = $credentials->getUserId();
      $password = $credentials->getPassword();
        
      $orbConfig = ORBConfig::getInstance();
      $security = $orbConfig->getSecurity();
      
        
      return  $security->isInRole($userName, $password, $this->m_roleName);

    }
    
	public function getDetails($grant)
	{
	  $reason = "Access to the resource has been rejected because the user ";

	  if( $grant )
		$reason .= "does not have";
	  else
		$reason .= "has" ;

	  $reason .= " credentials for the required role name";
		
	   return $reason;
	}
	
	public function getRoleName()
	{
      return $this->m_roleName;
    }
    
  }
?>