<?php
/*******************************************************************
 * Types.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/




	class Types
	{
		private $m_abstractMappings;
        private $m_clientMappings;
        private $m_serverMappings;
        
        public function __construct()
        {
          $this->m_abstractMappings = array();
          $this->m_clientMappings = array();
          $this->m_serverMappings = array();
        }
        
        
        public static function getAbstractClassMapping( $type )
        {
            return ORBConfig::getInstance()->getTypeMapper()->_getAbstractClassMapping( $type );
        }

		public function _getAbstractClassMapping( $type )
		{
			return $this->m_abstractMappings[ $type ];
		}

        public static function addAbstractTypeMapping($abstractType,ReflectionClass $mappedType )
        {
            ORBConfig::getInstance()->getTypeMapper()->_addAbstractTypeMapping( $abstractType, $mappedType );
        }

		public function _addAbstractTypeMapping($abstractType, $mappedType )
		{
			$this->m_abstractMappings[ $abstractType ] = $mappedType;
		}

        public static function addClientClassMapping($clientClass, ReflectionClass $mappedServerType )
        {
            ORBConfig::getInstance()->getTypeMapper()->_addClientClassMapping( $clientClass,  $mappedServerType );
        }

        public function _AddClientClassMapping( $clientClass, ReflectionClass $mappedServerType )
        {
            $this->m_clientMappings[ $clientClass ] = $mappedServerType;
            $this->m_serverMappings[ $mappedServerType->getName() ] = $clientClass;
        }

        public static function getServerTypeForClientClass( $clientClass )
        {
            return ORBConfig::getInstance()->getTypeMapper()->_getServerTypeForClientClass( $clientClass );
        }

        public function _getServerTypeForClientClass( $clientClass )
        {
          if(array_key_exists($clientClass,$this->m_clientMappings))
            return $this->m_clientMappings[ $clientClass ];
            
          return null;
        }

        public static function getClientClassForServerType( $serverClassName )
        {

            return ORBConfig::getInstance()->getTypeMapper()->_getClientClassForServerType( $serverClassName );
        }

        public function _getClientClassForServerType( $serverClassName )
        {
            Log::log(LoggingConstants::DEBUG, $serverClassName);
          
            if(array_key_exists($serverClassName,$this->m_serverMappings))
                return $this->m_serverMappings[ $serverClassName ];
                
            return null;
        }
	}


?>