<?php
/*******************************************************************
 * LoggingConstants.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



class LoggingConstants
{   
    const INFO          = 0x0001;
    const EXCEPTION     = 0x0002;  
    const ERROR         = 0x0008;      
    const DEBUG         = 0x0020;   
    const DEBUG_LEVEL_2 = 0x0040;   
    const DEBUG_LEVEL_3 = 0x0080;
    const SECURITY      = 0x0200;
    const PERFORMANCE   = 0x0800; 
       
    private static $s_names = null;
    
    public static function getLogChannelName($logType)
    {
      if(self::$s_names == null)
      {
         self::$s_names = array();
         self::$s_names[LoggingConstants::INFO] = "Info";
         self::$s_names[LoggingConstants::EXCEPTION] = "Exception";
         self::$s_names[LoggingConstants::ERROR] = "Error";
         self::$s_names[LoggingConstants::DEBUG_LEVEL_2] = "Debug Level 2";
         self::$s_names[LoggingConstants::DEBUG_LEVEL_3] = "Debug Level 3";  
         self::$s_names[LoggingConstants::DEBUG] = "Debug";      
         self::$s_names[LoggingConstants::SECURITY] = "Security";   
         self::$s_names[LoggingConstants::PERFORMANCE] = "Performance";            
      }
      
      return self::$s_names[$logType];
    }
}

?>
