<?php
/*******************************************************************
 * ThreadContext.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/
 
 require_once(WebOrb . "Security/Credentials.php");    
 require_once(WebOrb . "Config/ORBConfig.php");  
 
 class ThreadContext
 {
   private static $s_instance = null;
   
   private function __construct()
   {
      //session_start();
   }
   public static function getInstance()
   {
     if(self::$s_instance == null)   
     {
        self::$s_instance = new ThreadContext();
     }
     
     return self::$s_instance;
   }
   
   public static function currentCallerCredentials()
   { 
     return self::getInstance()->getCredentials();
   }
   
   private function setCredentials($currentCallerCredentials)
   {
      $_SESSION["credentials"] = $currentCallerCredentials;
   }
   
   private function getCredentials()
   {
      return $_SESSION["credentials"];
   }   
   
   public static function setCallerCredentials($currentCallerCredentials)
   {
      self::getInstance()->setCredentials($currentCallerCredentials);
   }
   
   public static function getORBConfig()
   {
     return ORBConfig::getInstance();
   }
 }

?>