<?php
/*******************************************************************
 * XmlUtil.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



class XmlUtil
{

    public static function getElementText(DOMElement $element, $elementName)
    {
        $nodeList = $element->getElementsByTagName($elementName);

        if (is_null($nodeList) || (0 == $nodeList->length))
        {
            return null;
        }

        $node = $nodeList->item(0);

        if (is_null($node))
        {
            return null;
        }

        return $node->textContent;
    }

    public static function getAttributeText(DOMElement $element, $attrName, $elementName = null)
    {
        if (is_null($elementName))
        {
            $attr = $element->getAttribute($attrName);
        }
        else
        {
            $nodeList = $element->getElementsByTagName($elementName);

            if (is_null($nodeList) || (0 == $nodeList->length))
            {
                return null;
            }

            $node = $nodeList->item(0);

            if (is_null($node))
            {
                return null;
            }

            $attr = $node->getAttribute($attrName);
        }

        if (is_null($attr))
        {
            return null;
        }

        return $attr->value;
    }

}

?>
