<?php
/*******************************************************************
 * AckMessage.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/


    require_once(WebOrb . "V3Types/V3Message.php");
    require_once(WebOrb . "Message/Request.php");
    require_once(WebOrb . "V3Types/BodyHolder.php");
    
    class AckMessage
          extends V3Message
    {
      
      public function __construct($correlationId,$clientId, $obj)
      {
           
        $this->correlationId = $correlationId;
        $this->clientId = is_null($clientId) ? self::uuid() : $clientId;
        $this->messageId = self::uuid();
        

        $this->timestamp = mktime();
        $this->body = new BodyHolder();
        $this->body->setBody($obj);
        $this->destination = "";
        $this->error = false;

        $this->headers = array(0);
        
        $this->timeToLive = 0;
      }
      
      public function execute(Request $request)
      {
        throw new Exception( "AckMessage should never be execution target" );
      }
      
    public static function uuid()
    {
        return sprintf(
            '%08X-%04X-%04X-%02X%02X-%012X',
            mt_rand(),
            mt_rand(0, 65535),
            bindec(substr_replace(
            sprintf('%016b', mt_rand(0, 65535)), '0100', 11, 4)
            ),
            bindec(substr_replace(sprintf('%08b', mt_rand(0, 255)), '01', 5, 2)),
            mt_rand(0, 255),
            mt_rand()
        );
    }


    }

?>
