<?php
/*******************************************************************
 * DataMessage.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/


    require_once(WebOrb . "V3Types/V3Message.php");
    require_once(WebOrb . "V3Types/AckMessage.php");
    
    class DataMessage
        extends V3Message
    {
      public $operation;
      
      public function setOperation($operation)
      {
        $this->operation = $operation;
      }
      
      public function getOperation()
      {
        return $this->operation;
      }
      
      public function execute(Request $request)
      {
        
            switch($this->operation)
            {
					case 1: // fill					
						return $this->handleFillRequest();

					case 3: // update
						return $this->handleUpdate();

					case 4: // delete
						return $this->handleDelete();

					case 7: // transaction
						return $this->handleTransaction( $request );

					case 8: // page
						return $this->handlePagingRequest();

					case 11: // create and sequence
						return $this->handleCreateAndSequence();

                    case 18: // collection release
                        return new AckMessage( $this->messageId, $this->clientId, null );
            }
          
      }

      private function handleFillRequest()
      {
        Log::log(LoggingConstants::DEBUG, "Called");
        
        $pageSize = -1;
        $sequenceId = -1;
        $totalRecords = 0;
        $adaptedArgs = null;
        $dataList = array();
        
        if(array_key_exists("pageSize",$this->headers))
            $pageSize = (int)$this->headers["pageSize"];
            
        
        return null;
      }
      
      private function handleUpdate()
      {
        Log::log(LoggingConstants::DEBUG, "Called");
        
        return null;
      }
      
      private function handleDelete()
      {
        Log::log(LoggingConstants::DEBUG, "Called");
        
        return null;
      }
      
      private function handleTransaction()
      {
        Log::log(LoggingConstants::DEBUG, "Called");
        
        return null;
      }
      
      private function handlePagingRequest()
      {
        Log::log(LoggingConstants::DEBUG, "Called");
        
        return null;
      }
      
      private function handleCreateAndSequence()
      {
        Log::log(LoggingConstants::DEBUG, "Called");
        
        return null;
      }
    
      
    }

?>