<?php
/*******************************************************************
 * ErrMessage.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/


    require_once(WebOrb . "V3Types/AckMessage.php");

    class ErrMessage
            extends AckMessage
    {
		public $rootCause;
 	    public $faultString;
		public $faultCode = "Server.Processing";
		public $extendedData;
		public $faultDetail;

        private $m_authException;
        
		public function __construct( $correlationId, $exception )
		{
			parent::__construct( $correlationId, null, null );
			$this->rootCause = $exception->getTraceAsString();
			$this->faultString = $exception->getMessage();
			$this->extendedData = $exception->__toString();
			$this->faultDetail = $exception->__toString();
			$this->error = TRUE;
			$this->m_authException = ($exception instanceof WebORBAuthenticationException);
		}
		
		public function isAuthentication()
		{
          return $this->m_authException;
        }
    }
?>