<?php
/*******************************************************************
 * AMFMessageWriter.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



require_once(WebOrb . "Writer/IProtocolFormatter.php");
require_once(WebOrb . "Writer/ITypeWriter.php");
require_once(WebOrb . "Writer/MessageWriter.php");
require_once(WebOrb . "Util/Logging/Log.php");

class AMFMessageWriter
    implements ITypeWriter
{

    public function __construct()
    {
    }

    public function isReferenceableType()
    {
        return false;
    }

    public function write(&$obj, IProtocolFormatter $writer)
    {
        $writer->beginWriteMessage($obj);
        $writer->writeMessageVersion($obj->getVersion());
        $headers = $obj->getResponseHeaders();
        $bodies = $obj->getResponseBodies();

        Log::log(LoggingConstants::DEBUG, "got headers " . count($headers));
        Log::log(LoggingConstants::DEBUG, "got bodies " . count($bodies));
        Log::log(LoggingConstants::DEBUG, "message version: " . $obj->getVersion());

        $writer->directWriteShort(count($headers));

        for ($index = 0; $index < count($headers); $index ++)
        {
            MessageWriter::writeObject($headers[$index], $writer);
        }

        $writer->directWriteShort(count($bodies));

        for ($index = 0; $index < count($bodies); $index ++)
        {
            MessageWriter::writeObject($bodies[$index], $writer);
        }

        $writer->endWriteMessage();
    }

}

?>
