<?php
/*******************************************************************
 * DataTableAsListWriter.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/
 
require_once(WebOrb . "Util/IDatabaseReader.php");
require_once(WebOrb . "Reader/Dataset/RemotingDataSet.php");
 
class DataTableAsListWriter
    implements ITypeWriter
{
    public function isReferenceableType()
    {
        return false;
    }

    public function write(&$obj, IProtocolFormatter $writer)
    {
        $dbReader = DatabaseReaderFactory::getReader($obj->getDatabaseName());
        
        if($dbReader == null)
        {
            Log::log(LoggingConstants::ERROR,"Database reader for " . $databaseName . " not found");
            
            $writer->writeNull();
            
            return;
        }
        
        $arr = array();
    
        while($object = $dbReader->readObject($obj->getResource()))
            $arr[] = $object;
            
        if($writer instanceof AmfV3Formatter)
            MessageWriter::writeObject($arr,$writer);
        else
        {
            $remotingDataSet = new RemotingDataSet($arr);
        
            MessageWriter::writeObject($remotingDataSet->getDataSetInfo(),$writer);            
        } 
    }
}

?>