<?php
/*******************************************************************
 * IProtocolFormatter.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



require_once(WebOrb . "Message/Request.php");
require_once(WebOrb . "Util/ORBDateTime.php");

interface IProtocolFormatter
{

    function beginWriteArray($length);
    function beginWriteFieldValue();
    function beginWriteMessage(Request $message);
    function beginWriteNamedObject($objectName, $fieldCount = null);
    function beginWriteObject($fieldCount = null);
    function beginWriteObjectMap($size);
    function cleanup();
    function directWriteBoolean($b);
    function directWriteInt($i);
    function directWriteShort($s);
    function directWriteString($str);
    function endWriteArray();
    function endWriteFieldValue();
    function endWriteMessage();
    function endWriteNamedObject();
    function endWriteObject();
    function endWriteObjectMap();
    function getBytes();
    function getContentType();
    function writeBoolean($b);
    function writeDate(ORBDateTime $datetime);
    function writeFieldName($s);
    function writeMessageVersion($version);
    function writeNull();
    function writeNumber($number);
    function writeReference($refId);
    function writeString($s);
    function getObjectSerializer();
    function getReferenceCache();
    function resetReferenceCache();
    function beginWriteBodyContent();
    function endWriteBodyContent();


    // function writeXML($document);

}

?>
