<?php
/*******************************************************************
 * V3ReferenceCache.php
 * Copyright (C) 2006 Midnight Coders, LLC
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * The software is licensed under the GNU General Public License (GPL)
 * For details, see http://www.gnu.org/licenses/gpl.txt.
 ********************************************************************/



require_once(WebOrb . "Writer/ReferenceCache.php");

class V3ReferenceCache
    extends ReferenceCache
{

    private $m_objectCache;
    private $m_stringCache;

    public function __construct()
    {
        $this->reset();
    }

    public function reset()
    {
        $this->m_objectCache = array();
        $this->m_stringCache = array();
    }

    public function addObject(&$obj)
    {
        if (is_string($obj))
        {
            $this->m_stringCache[$obj] = count($this->m_stringCache);
        }
        else
        {
            $this->m_objectCache[] = &$obj;
        }
    }

    public function getId(&$obj)
    {
        if (is_string($obj))
        {
            return $this->m_stringCache[$obj];
        }
        else
        {
            for ($i = 0; $i < count($this->m_objectCache); $i ++)
            {
                if ($obj === $this->m_objectCache[$i])
                {
                    return $i;
                }
            }
        }

        throw new Exception("Unknown object");
    }

    public function hasObject(&$obj)
    {
        if (is_string($obj))
        {
            return array_key_exists($obj,$this->m_stringCache);
        }
        else
        {
            //return in_array($obj,$this->m_objectCache);
            
            for ($i = 0; $i < count($this->m_objectCache); $i ++)
            {
                if ($obj === $this->m_objectCache[$i])
                {
                    return true;
                }
            }
        }

        return false;
    }

}

?>
